/*----- PROTECTED REGION ID(Logix5000.java) ENABLED START -----*/
//=============================================================================
//
// file :        Logix5000.java
//
// description : Java source for the Logix5000 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Logix5000 are implemented in this file.
//
// project :     Logix5000
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
// Copyright (C): 2004,2005,2006,2007,2008,2009,2009,2010,2011,2012,2013,2014,2015
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

/*----- PROTECTED REGION END -----*/	//	Logix5000.java

package org.tango.logix5000;

/*----- PROTECTED REGION ID(Logix5000.imports) ENABLED START -----*/
import fr.esrf.TangoApi.DeviceProxy;
import fr.esrf.TangoDs.TangoConst;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.ext.XLogger;
import org.slf4j.ext.XLoggerFactory;
import org.tango.server.InvocationContext;
import org.tango.server.ServerManager;
import org.tango.server.annotation.*;
import org.tango.server.annotation.Device;
import org.tango.server.dynamic.DynamicManager;
import org.tango.server.device.DeviceManager;

//	Import Tango IDL types
import fr.esrf.Tango.*;
import fr.esrf.TangoDs.Except;
import se.opendataexchange.ethernetip4j.EthernetIPException;
import se.opendataexchange.ethernetip4j.clx.SimpleLogixCommunicator;

import java.text.SimpleDateFormat;
import java.util.List;
import java.util.Vector;


import static org.tango.command.CommandTangoType.VOID;

/*----- PROTECTED REGION END -----*/	//	Logix5000.imports

/**
 *  Logix5000 class description:
 *    A class to handle Logix5000 Allen Bradley PLC
 */

@Device
public class Logix5000 {

	protected static final Logger logger = LoggerFactory.getLogger(Logix5000.class);
	protected static final XLogger xlogger = XLoggerFactory.getXLogger(Logix5000.class);
	//========================================================
	//	Programmer's data members
	//========================================================
    /*----- PROTECTED REGION ID(Logix5000.variables) ENABLED START -----*/
    
		public final static SimpleDateFormat dfr = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");

    /*----- PROTECTED REGION END -----*/	//	Logix5000.variables
	/*----- PROTECTED REGION ID(Logix5000.private) ENABLED START -----*/
	
	//	Put private variables here

  private SimpleLogixCommunicator plc=null;

  class CheckedAttribute {
    String attName;
    String text;

    boolean bValue;
  }

  private Vector<CheckedAttribute> alarmsAtt;

  private DeviceProxy self=null;
  private long lastStateRefresh = 0;
	private DevState lastState = DevState.ON;
	private long enterMailAlarm;
	private boolean emailSent;
  private String SMTPServer;
	private String emailAddress;
	private long emailAlarmTime;
	private String errMail = "None";
	private MailSender sender;

	/*----- PROTECTED REGION END -----*/	//	Logix5000.private

	//========================================================
	//	Property data members and related methods
	//========================================================
	/**
	 * Device Property ItemNames
	 * List of TAG to exports:
	 * Type,Tag_name[,length][,name][,level][,factor][,resetable]
	 * 
	 * where:
	 * Type = [RW]Type (i.e. Double, RWBoolean)
	 * Tag_name= Name of the TAG inside the PLC
	 * length= Array size
	 * name= Tango attribute name
	 * level= operator or expert
	 * factor= multiplication factor
	 * resetable= ResetCommand
	 */
	@DeviceProperty(name="ItemNames", description="List of TAG to exports:\nType,Tag_name[,length][,name][,level][,factor][,resetable]\n\nwhere:\nType = [RW]Type (i.e. Double, RWBoolean)\nTag_name= Name of the TAG inside the PLC\nlength= Array size\nname= Tango attribute name\nlevel= operator or expert\nfactor= multiplication factor\nresetable= ResetCommand"  )
	private String[] itemNames;
	/**
	 * set property ItemNames
	 * @param  itemNames  see description above.
	 */
	public void setItemNames(String[] itemNames) {
		this.itemNames = itemNames;
		/*----- PROTECTED REGION ID(Logix5000.setItemNames) ENABLED START -----*/
		
		//	Check property value here
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.setItemNames
	}
	
	/**
	 * Device Property PLCAddress
	 * 
	 */
	@DeviceProperty(name="PLCAddress", description=""  )
	private String pLCAddress;
	/**
	 * set property PLCAddress
	 * @param  pLCAddress  see description above.
	 */
	public void setPLCAddress(String pLCAddress) {
		this.pLCAddress = pLCAddress;
		/*----- PROTECTED REGION ID(Logix5000.setPLCAddress) ENABLED START -----*/
		
		//	Check property value here
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.setPLCAddress
	}
	
	/**
	 * Device Property AlarmAttributes
	 * List of:
	 * AttributeName,value,Alarm Text
	 * State swith to alarm if one Tag in the list if equal to value.
	 * Only boolean scalar value are supported (value can be ``true`` or ``false``)
	 */
	@DeviceProperty(name="AlarmAttributes", description="List of:\nAttributeName,value,Alarm Text\nState swith to alarm if one Tag in the list if equal to value.\nOnly boolean scalar value are supported (value can be ``true`` or ``false``)"  )
	private String[] alarmAttributes;
	/**
	 * set property AlarmAttributes
	 * @param  alarmAttributes  see description above.
	 */
	public void setAlarmAttributes(String[] alarmAttributes) {
		this.alarmAttributes = alarmAttributes;
		/*----- PROTECTED REGION ID(Logix5000.setAlarmAttributes) ENABLED START -----*/
		
		//	Check property value here
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.setAlarmAttributes
	}
	
	/**
	 * Device Property MailAlarm
	 * SMTP server
	 * email address
	 * email subject
	 * alarm time (sec)
	 */
	@DeviceProperty(name="MailAlarm", description="SMTP server\nemail address\nemail subject\nalarm time (sec)"  )
	private String[] mailAlarm;
	/**
	 * set property MailAlarm
	 * @param  mailAlarm  see description above.
	 */
	public void setMailAlarm(String[] mailAlarm) {
		this.mailAlarm = mailAlarm;
		/*----- PROTECTED REGION ID(Logix5000.setMailAlarm) ENABLED START -----*/
		
		//	Check property value here
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.setMailAlarm
	}
	


	//========================================================
	//	Miscellaneous methods
	//========================================================
	/**
	 * Initialize the device.
	 * 
	 * @throws DevFailed if something fails during the device initialization.
	 */
	@Init(lazyLoading = false)
	public void initDevice() throws DevFailed {
		xlogger.entry();
		logger.debug("init device " + deviceManager.getName());
		/*----- PROTECTED REGION ID(Logix5000.initDevice) ENABLED START -----*/
		
		//	Put your device initialization code here

    if(pLCAddress.length()==0) {
      Except.throw_exception(
          "error_init",
          "PLCAddress property not defined",
          "Logix5000.initDevice()"
      );
    }

    if(itemNames.length==0) {
      Except.throw_exception(
          "error_init",
          "ItemNames property not defined",
          "Logix5000.initDevice()"
      );
    }

    alarmsAtt = new Vector<CheckedAttribute>();
    for (String alarmAttribute : alarmAttributes) {
      String[] fields = alarmAttribute.split(",");
      if (fields.length != 3) {
        Except.throw_exception(
                "error_init",
                "AlarmAttributes property wrong definition, 3 items per line expected",
                "Logix5000.initDevice()"
        );
      }
      CheckedAttribute a = new CheckedAttribute();
      a.attName = fields[0];
      String value = fields[1];
      if(! (value.equalsIgnoreCase("true") || value.equalsIgnoreCase("false")) ) {
        Except.throw_exception(
                "error_init",
                "AlarmAttributes property wrong definition, value can be only true or false",
                "Logix5000.initDevice()"
        );
      }
      a.bValue = value.equalsIgnoreCase("true");
      a.text = fields[2];
      alarmsAtt.add(a);
    }

    // Connect to the PLC
    try {
      plc = new SimpleLogixCommunicator(pLCAddress, 44818);
    } catch(EthernetIPException e) {
      setState(DevState.UNKNOWN);
      setStatus(e.getMessage());
    }

    self = new DeviceProxy(deviceManager.getName());

    // Add dynamic attribute
    for (String itemName : itemNames) {
      TaggedAttribute ta = new TaggedAttribute(deviceManager.getName(), plc, itemName);
      dynamicManager.addAttribute(ta);
      if (!ta.getResetCommand().isEmpty()) {
        ResetCommand rs = new ResetCommand(ta, ta.getResetCommand());
        dynamicManager.addCommand(rs);
        ta.initResetAttribute();
      }
    }

		enterMailAlarm = 0;
		email_Count = 0;
		emailSent = false;
		String subject;
		if(mailAlarm.length==4) {
			SMTPServer = mailAlarm[0];
			emailAddress = mailAlarm[1];
			subject = mailAlarm[2];
			emailAlarmTime = Long.parseLong(mailAlarm[3]);
			sender = new MailSender(SMTPServer,subject);
		} else {
			sender=null;
		}

		state = DevState.ON;
		status = "";

		/*----- PROTECTED REGION END -----*/	//	Logix5000.initDevice
		xlogger.exit();
	}

	/**
	 * all resources may be closed here. Collections may be also cleared.
	 * 
	 * @throws DevFailed if something fails during the device object deletion.
	 */
	@Delete
	public void deleteDevice() throws DevFailed {
		xlogger.entry();
		/*----- PROTECTED REGION ID(Logix5000.deleteDevice) ENABLED START -----*/
		
		//	Put your device clearing code here
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.deleteDevice
		xlogger.exit();
	}

	/**
	 * Method called before and after command and attribute calls.
	 * @param ctx the invocation context
	 * @throws DevFailed if something fails during this method execution.
	 */
	@AroundInvoke
	public void aroundInvoke(final InvocationContext ctx) throws DevFailed {
		xlogger.entry();
			/*----- PROTECTED REGION ID(Logix5000.aroundInvoke) ENABLED START -----*/
			
			//	Put aroundInvoke code here
			
			/*----- PROTECTED REGION END -----*/	//	Logix5000.aroundInvoke
		xlogger.exit();
	}

	
	/**
	 * dynamic command and attribute management. Will be injected by the framework.
	 */
	@DynamicManagement
	protected DynamicManager dynamicManager;
	/**
	 * @param dynamicManager the DynamicManager instance 
	 * @throws DevFailed if something fails during this method execution.
	 */
	public void setDynamicManager(final DynamicManager dynamicManager) throws DevFailed {
		this.dynamicManager = dynamicManager;
		/*----- PROTECTED REGION ID(Logix5000.setDynamicManager) ENABLED START -----*/
		
		//	Put your code here
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.setDynamicManager
	}
	
	/**
	 * Device management. Will be injected by the framework.
	 */
	@DeviceManagement
	DeviceManager deviceManager;
	public void setDeviceManager(DeviceManager deviceManager){
		this.deviceManager= deviceManager ;
	}


	//========================================================
	//	Attribute data members and related methods
	//========================================================
	/**
	 * Attribute Email_Count, int, Scalar, READ
	 * description:
	 *     
	 */
	@Attribute(name="Email_Count", displayLevel=DispLevel._EXPERT)
	private int email_Count;
	/**
	 * Read attribute Email_Count
	 * 
	 * @return attribute value
	 * @throws DevFailed if read attribute failed.
	 */
	public org.tango.server.attribute.AttributeValue getEmail_Count() throws DevFailed {
		xlogger.entry();
		org.tango.server.attribute.AttributeValue
			attributeValue = new org.tango.server.attribute.AttributeValue();
		/*----- PROTECTED REGION ID(Logix5000.getEmail_Count) ENABLED START -----*/
		

		/*----- PROTECTED REGION END -----*/	//	Logix5000.getEmail_Count
		attributeValue.setValue(email_Count);
		xlogger.exit();
		return attributeValue;
	}
	


	//========================================================
	//	Command data members and related methods
	//========================================================
	/**
	 * The state of the device
	*/
	@State 
	private DevState state = DevState.UNKNOWN;
	/**
	 * Execute command "State".
	 * description: This command gets the device state (stored in its 'state' data member) and returns it to the caller.
	 * @return Device state
	 * @throws DevFailed if command execution failed.
	 */
	public final DevState getState() throws DevFailed {
		/*----- PROTECTED REGION ID(Logix5000.getState) ENABLED START -----*/

		// TODO: Improve me (is there a way to know that we come from DevState command)
		long now = System.currentTimeMillis();
		if( now-lastStateRefresh < 2000 ) {
			return state;
		}
		lastStateRefresh = now;

		setStatus("State: " + TangoConst.Tango_DevStateName[state.value()]);

    if(plc!=null) {

      if (!alarmsAtt.isEmpty()) {

        StringBuffer alarmStr = new StringBuffer();
        try {
					for (CheckedAttribute checkedAttribute : alarmsAtt) {
						Boolean v = (Boolean) dynamicManager.getAttribute(checkedAttribute.attName).getValue().getValue();
						if (v == checkedAttribute.bValue)
							alarmStr.append(checkedAttribute.text).append("\n");
					}
        } catch (DevFailed e) {
					System.out.println(e.errors[0].desc);
          state = DevState.UNKNOWN;
          setStatus(e.errors[0].desc);
        }
        if (alarmStr.length()>0) {
          state = DevState.ALARM;
          setStatus(alarmStr.toString());
        } else {
					state = DevState.ON;
				}

      } else {
				state = DevState.ON;
			}

			List attr = dynamicManager.getDynamicAttributes();
      for (Object o : attr) {
        TaggedAttribute ta = (TaggedAttribute) o;
				if(!ta.getResetCommand().isEmpty()) {
					long lastReset = ta.getResetDate() * 1000;
					String lastResetDate = "Never";
					if(lastReset!=0) lastResetDate = dfr.format(lastReset);
					setStatus(getStatus() + "\n" + "Last " + ta.getResetCommand() + ": " + lastResetDate);
				}
      }

			if( sender!=null ) {

				if (state != lastState) {

					lastState = state;
					if (state == DevState.ALARM && enterMailAlarm == 0) {
						enterMailAlarm = now;
					} else {
						enterMailAlarm = 0;
						emailSent = false;
					}

				}

				if (!emailSent && enterMailAlarm > 0 && ((now - enterMailAlarm) / 1000) >= emailAlarmTime) {
					String mailMessage = deviceManager.getName() + ":\n" + getStatus() + "\n";
					// Operator attribute
					for (Object o : attr) {
						TaggedAttribute ta = (TaggedAttribute) o;
						if(ta.isOperator())
  						mailMessage += "\n" + ta.getValueAsStr();
					}
					mailMessage += "\n";
					// Expert attribute
					for (Object o : attr) {
						TaggedAttribute ta = (TaggedAttribute) o;
						if(!ta.isOperator())
							mailMessage += "\n" + ta.getValueAsStr();
					}
					emailSent = true;
					errMail = sendMail(mailMessage);
				}

				// Debug
				//setStatus(getStatus() + "\nenterMailAlarm:" + enterMailAlarm);
				//setStatus(getStatus() + "\nTime:" + (now - enterMailAlarm));
				//setStatus(getStatus() + "\nemailSent:" + emailSent);
				//setStatus(getStatus() + "\nerrMail:" + errMail);

			}

    }

		/*----- PROTECTED REGION END -----*/	//	Logix5000.getState
		return state;
	}
	/**
	 * Set the device state
	 * @param state the new device state
	 */
	public void setState(final DevState state) {
		this.state = state;
	}
	
	/**
	 * The status of the device
	 */
	@Status 
	private String status = "Server is starting. The device state is unknown";
	/**
	 * Execute command "Status".
	 * description: This command gets the device status (stored in its 'status' data member) and returns it to the caller.
	 * @return Device status
	 * @throws DevFailed if command execution failed.
	 */
	public final String getStatus() throws DevFailed {
		/*----- PROTECTED REGION ID(Logix5000.getStatus) ENABLED START -----*/
		
		//	Put status code here
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.getStatus
		return status;
	}
	/**
	 * Set the device status
	 * @param status the new device status
	 */
	public void setStatus(final String status) {
		this.status = status;
	}
	

	//========================================================
	//	Programmer's methods
	//========================================================
	/*----- PROTECTED REGION ID(Logix5000.methods) ENABLED START -----*/
	
	//	Put your own methods here
	private String sendMail(String myMsg) {

		long now = System.currentTimeMillis();
		if( !sender.SendMessage(emailAddress,"donotreply@site.com",dfr.format(now),myMsg) ) {
			return sender.GetLastError();
		} else {
			email_Count++;
			return "No Error";
		}

	}
	
	/*----- PROTECTED REGION END -----*/	//	Logix5000.methods


	
	
	
	
	/**
	 * Starts the server.
	 * @param args program arguments (instance_name [-v[trace level]]  [-nodb [-dlist <device name list>] [-file=fileName]])
	 */
	public static void main(final String[] args) {
		/*----- PROTECTED REGION ID(Logix5000.main) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	Logix5000.main
		ServerManager.getInstance().start(args, Logix5000.class);
		System.out.println("------- Started -------------");
	}
}
